<template>
  <div class="hello">
    <input
      type="text"
      :placeholder="`Message #${roomName}`"
      v-model="message"
      @keyup.enter="sendMessage"
      @keydown="isTyping"
      autofocus
    />
    <button @click="sendMessage">Send</button>
    <div v-if="usersTyping.length">{{usersTypingStr}}</div>
  </div>
</template>

<script>
export default {
  name: "Prompt",
  props: {
    roomName: String,
    usersTyping: Array,
  },
  data: function() {
    return {
      message: "",
      typingState: false,
      typingInterval: null,
    };
  },
  computed: {
    usersTypingStr: function() {
      if (this.usersTyping.length === 0) return "";

      return `${this.usersTyping.join(', ')} ${this.usersTyping.length === 1 ? "is" : "are"} typing...`;
    }
  },
  watch: {
    typingState: function(isTyping) {
      if (isTyping === true)
        return this.$socket.emit("typing");
      
      return this.$socket.emit("typingStop");
    }
  },
  methods: {
    isTyping: function() {
      const now = Date.now();
      console.log('yo', now, this.lastTyping, now - this.lastTyping, now - this.lastTyping < 1000);
      if (now - this.lastTyping < 1000)
        return;

      this.lastTyping = now;

      this.typingState = true;
      if (this.typingInterval) {
        clearInterval(this.typingInterval);
      }

      this.typingInterval = setTimeout(() => this.stoppedTyping(), 3000);
    },
    stoppedTyping: function() {
      console.log("stoppedTyping");
      this.lastTyping = 0;
      this.typingState = false;
      clearInterval(this.typingInterval);
      this.typingInterval = null;
    },
    sendMessage: function() {
      this.$socket.emit("message", { content: this.message });
      this.message = "";
      this.stoppedTyping();
    }
  }
};
</script>
